﻿using System;
using System.Windows;
using System.Windows.Controls;

namespace SQLServerClient
{
    public class TreeNode : TreeViewItem
    {
        public TreeNode(string name, TreeNodeType type, int level)
        {
            this.Header = name;
            this.Name = name;
            this.NodeType = type;
            this.Level = level;
        }
        public TreeNodeType NodeType { get; set; }
        public int Level { get; set; }
    }
    public enum TreeNodeType
    {
        Table = 1,
        View = 2,
        Procedure = 3,
        Function = 4,
    }

    public class DGColumn : DataGridColumn
    {
        public DGColumn(string name)
        {
            this.Header = name;
        }
        protected override FrameworkElement GenerateEditingElement(DataGridCell cell, object dataItem)
        {
            return null;
        }
        protected override FrameworkElement GenerateElement(DataGridCell cell, object dataItem)
        {
            return null;
        }
    }
}
