﻿using System;

namespace SQLServerClient
{
    public class Sqls
    {
        public const string get_objects = @"select id,name from sysobjects where xtype='{0}'and name<>'dtproperties' order by name;";

        public const string get_columns = @"SELECT 
syscolumns.name AS ColumnName,
systypes.name AS Type, 
syscolumns.length,
syscolumns.isnullable  
FROM sysobjects
INNER JOIN syscolumns ON sysobjects.id = syscolumns.id
INNER JOIN systypes ON syscolumns.xtype = systypes.xtype
WHERE (sysobjects.name <> 'dtproperties')
AND (sysobjects.name = '{0}')
AND (systypes.name <> 'sysname')
AND (systypes.status <> 3)
GROUP BY syscolumns.name, sysobjects.name, syscolumns.xtype,systypes.name, syscolumns.length,syscolumns.isnullable
;";
        public const string get_text = @"sp_helptext '{0}'";

        public const string get_insert = @"declare @tablename sysname 
set @tablename='{0}'
declare @column varchar(1000) 
declare @columndata varchar(1000) 
declare @sql varchar(4000) 
declare @xtype tinyint 
declare @name sysname 
declare @objectId int 
declare @objectname sysname 
declare @ident int 

set nocount on 
set @objectId=object_id(@tablename) 

select @ident=status&0x80 from syscolumns where id=@objectid and status&0x80=0x80 

if @ident is not null 
select 'SET IDENTITY_INSERT '+@TableName+' ON' 

declare syscolumns_cursor cursor 
for select c.name,c.xtype from syscolumns c 
where c.id=@objectid 
order by c.colid 
open syscolumns_cursor 
set @column='' 
set @columndata='' 
fetch next from syscolumns_cursor into @name,@xtype 
while @@fetch_status < >-1 
begin 
if @@fetch_status < >-2 
begin 
if @xtype not in(189,34,35,99,98) 
begin 
set @column=@column+(case when len(@column)=0 then'' else ','end)+'['+@name+']' 
set @columndata=@columndata+case when len(@columndata)=0 then '' else ','','','end 
+case when @xtype in(167,175) then '''''''''+'+@name+'+'''''''''
when @xtype in(231,239) then '''N''''''+'+@name+'+'''''''''
when @xtype=61 then '''''''''+convert(char(23),'+@name+',121)+'''''''''
when @xtype=58 then '''''''''+convert(char(16),'+@name+',120)+'''''''''
when @xtype=36 then '''''''''+convert(char(36),'+@name+')+''''''''' 
else @name end 
end 
end 
fetch next from syscolumns_cursor into @name,@xtype 
end 
close syscolumns_cursor 
deallocate syscolumns_cursor 

set @sql='set nocount on select ''insert into ['+@tablename+']('+@column+') values(''as ''--'','+@columndata+','')'' from '+@tablename 

exec(@sql) 

if @ident is not null 
select 'SET IDENTITY_INSERT '+@TableName+' OFF' 
;";

        //获取自动增长列
        public const string get_identity = @"declare @objname nvarchar(776)
set @objname='{0}'
declare @objid int
set @objid=object_id(@objname) 
declare @colname sysname
select @colname = col_name(@objid, column_id) from sys.identity_columns where object_id = @objid
select
	'Identity'			= @colname,
	'Seed'				= ident_seed(@objname),
	'Increment'			= ident_incr(@objname)
;";
        //获取索引
        public const string get_index = @"exec sys.sp_helpindex '{0}';";
        //获取约束
        public const string get_constraint = @"exec sys.sp_helpconstraint '{0}','nomsg';";
    }
}
